/***************************************************************************
Name: View Cookies CS
Version: 1.0
Description: Basic cookie manager.
Author: Ron Beckman
Homepage: http://forum.softwareblaze.com
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/




var csViewCookies = {

	onDialogLoad: function() {
		var prefs = this.getPrefs();
		var settings = prefs.getCharPref('treeSettings');
		settings = settings.split('::');
		var hide = settings[0].split('||');
		var size = settings[1].split('||');
		var win = document.getElementById('viewcookiescsViewCookies');
		win.style.width = size[0]+'px';
		win.style.height = size[1]+'px';
		moveTo((screen.width-size[0])/2,(screen.height-size[1])/2);
		document.getElementById('cookies-site').setAttribute('hidden',hide[0]);
		document.getElementById('cookies-name').setAttribute('hidden',hide[1]);
		document.getElementById('cookies-value').setAttribute('hidden',hide[2]);
		document.getElementById('cookies-path').setAttribute('hidden',hide[3]);
		document.getElementById('cookies-secure').setAttribute('hidden',hide[4]);
		document.getElementById('cookies-expires').setAttribute('hidden',hide[5]);
		document.getElementById('cookies-expires-ms').setAttribute('hidden',hide[6]);
		document.getElementById('cookies-prtct').setAttribute('hidden',hide[7]);

		var list = document.getElementById('csVC-list');
		var all = document.getElementById('csVC-item-all');
		var cur = document.getElementById('csVC-item-cur');
		var filter = prefs.getBoolPref('filterTree');
		(filter) ? list.selectedItem = cur : list.selectedItem = all;
		(filter) ? this.filterTree() : this.load();
	},

	onDialogClose: function() {
		var hide = [];
		hide.push(document.getElementById('cookies-site').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-name').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-value').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-path').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-secure').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-expires').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-expires-ms').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-prtct').getAttribute('hidden'));
		var size = (window.outerWidth-8)+'||'+(window.outerHeight-25);
		var settings = hide.join('||') + '::' + size;
		var prefs = this.getPrefs();
		prefs.setCharPref('treeSettings',settings);

		var tf;
		var list = document.getElementById('csVC-list');
		(list.selectedItem.id=='csVC-item-cur') ? tf = true : tf = false;
		prefs.setBoolPref('filterTree',tf);

		var win = this.getMainWin();
		if (win.cookiesafe) {
			win.cookiesafe.resetIcon();
			win.cookiesafe.load();
		}
		window.close();
	},

	getSt: function(name) {
		var win = this.getMainWin();
		var strbdl = win.document.getElementById("viewcookiescs-bundle");
		var msg = strbdl.getString(name);
		return msg;
	},

	getMainWin: function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow("navigator:browser");
	},

	getCookies: function() {
		return Components.classes["@mozilla.org/cookiemanager;1"].
		getService(Components.interfaces.nsICookieManager);
	},

	getCookies2: function() {
		return Components.classes["@mozilla.org/cookiemanager;1"].
		getService(Components.interfaces.nsICookieManager2);
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("viewcookiescs.");
	},

	getData: function() {
		var item = [];
		var tree = document.getElementById('cookiestree');

		try {
			for (var i=0; i<tree.columns.count; ++i) {
				item.push(tree.view.getCellText(tree.currentIndex,tree.columns.getColumnAt(i)));
			}
		} catch(e) {
			return false;
		}
		return item;
	},

	removeChars: function(ck) {
		return ck.replace(/[~!@#$%^&*()_+|`\-=\\\[\];',.\/{}:"<>? ]/g,'');
	},

	testProtect: function(site) {
		var win = this.getMainWin();
		for (var i=0; i<win.viewcookiescs.protect.length; ++i) {
			if (win.viewcookiescs.protect[i]==site) return true;
		}
		return false;
	},

	removeProtect: function(site) {
		var win = this.getMainWin();
		for (var i=0; i<win.viewcookiescs.protect.length; ++i) {
			if (win.viewcookiescs.protect[i]==site) win.viewcookiescs.protect.splice(i,1);
		}
		return false;
	},

	saveProtect: function() {
		var prefs = this.getPrefs();
		var win = this.getMainWin();
		var cookies = "";
		for (var i=0; i<win.viewcookiescs.protect.length; ++i) {
			cookies += win.viewcookiescs.protect[i]+',,';
		}
		prefs.setCharPref('protected',cookies);
	},

	load: function() {
		this.clearColData();
		var ck,item,row,cell,exp,yn;
		var num = 0;

		var tree = document.getElementById('cookieschild');
		while (tree.firstChild) {
			tree.removeChild(tree.firstChild);
		}

		var cookies = this.getCookies();
		var list = cookies.enumerator;
		while (list.hasMoreElements()) {
			ck = list.getNext();
			ck.QueryInterface(Components.interfaces.nsICookie);

			item = document.createElement('treeitem');
			row = document.createElement('treerow');

			cell = document.createElement('treecell');
			cell.setAttribute('label',ck.host);
			row.appendChild(cell);

			cell = document.createElement('treecell');
			cell.setAttribute('label',ck.name);
			row.appendChild(cell);

			cell = document.createElement('treecell');
			cell.setAttribute('label',ck.value);
			row.appendChild(cell);

			cell = document.createElement('treecell');
			cell.setAttribute('label',ck.path);
			row.appendChild(cell);

			cell = document.createElement('treecell');
			cell.setAttribute('label',ck.isSecure);
			row.appendChild(cell);

			cell = document.createElement('treecell');
			if (ck.expires==0) {
				exp = this.getSt('viewcookiescs.Session');
			} else {
				var dt = new Date(1000 * ck.expires);
				exp = (dt.getMonth()+1)+'/'+dt.getDate()+'/'+dt.getFullYear();
			}
			cell.setAttribute('label',exp);
			row.appendChild(cell);

			cell = document.createElement('treecell');
			cell.setAttribute('label',ck.expires);
			row.appendChild(cell);

			cell = document.createElement('treecell');
			var nme = ck.name + '||' + ck.value + '||' + ck.host + '||' + ck.path + '||' + ck.isSecure + '||' + ck.expires;
			if (this.testProtect(nme)) {
				yn = this.getSt('viewcookiescs.Yes');
			} else {
				yn = this.getSt('viewcookiescs.No');
			}
			cell.setAttribute('label',yn);
			row.appendChild(cell);

			item.appendChild(row);
			tree.appendChild(item);
			++num;
		}

		document.getElementById('RemAllCks').setAttribute('disabled',(num>0) ? 'false' : 'true');
	},

	filterTree: function() {
		this.clearColData();
		var ck,item,row,cell,exp,yn,site,i,site2,site3;
		var a = 0;
		var num = 0;

		var tree = document.getElementById('cookieschild');
		while (tree.firstChild) {
			tree.removeChild(tree.firstChild);
		}

		site = this.getDomain();
		if (!site) {
			document.getElementById('RemAllCks').setAttribute('disabled',true);
			return false;
		}

		site = this.removeSub(site);
		var sstring = '/'+site+'/';

		var cookies = this.getCookies();
		var list = cookies.enumerator;
		while (list.hasMoreElements()) {
			ck = list.getNext();
			ck.QueryInterface(Components.interfaces.nsICookie);

			if (ck.host.search(eval(sstring))!=-1) {
				item = document.createElement('treeitem');
				row = document.createElement('treerow');

				cell = document.createElement('treecell');
				cell.setAttribute('label',ck.host);
				row.appendChild(cell);

				cell = document.createElement('treecell');
				cell.setAttribute('label',ck.name);
				row.appendChild(cell);

				cell = document.createElement('treecell');
				cell.setAttribute('label',ck.value);
				row.appendChild(cell);

				cell = document.createElement('treecell');
				cell.setAttribute('label',ck.path);
				row.appendChild(cell);

				cell = document.createElement('treecell');
				cell.setAttribute('label',ck.isSecure);
				row.appendChild(cell);

				cell = document.createElement('treecell');
				if (ck.expires==0) {
					exp = this.getSt('viewcookiescs.Session');
				} else {
					var dt = new Date(1000 * ck.expires);
					exp = (dt.getMonth()+1)+'/'+dt.getDate()+'/'+dt.getFullYear();
				}
				cell.setAttribute('label',exp);
				row.appendChild(cell);

				cell = document.createElement('treecell');
				cell.setAttribute('label',ck.expires);
				row.appendChild(cell);

				cell = document.createElement('treecell');
				var nme = ck.name + '||' + ck.value + '||' + ck.host + '||' + ck.path + '||' + ck.isSecure + '||' + ck.expires;
				if (this.testProtect(nme)) {
					yn = this.getSt('viewcookiescs.Yes');
				} else {
					yn = this.getSt('viewcookiescs.No');
				}
				cell.setAttribute('label',yn);
				row.appendChild(cell);

				item.appendChild(row);
				tree.appendChild(item);
				++num;
			}
		}

		document.getElementById('RemAllCks').setAttribute('disabled',(num>0) ? 'false' : 'true');
		return false;
	},

	getDomain: function() {
		var win = this.getMainWin();

		var site;
		try {
			if (win.content.document) {
				site = win.content.document.domain;
			} else {
				site = null;
			}
		} catch(e) {
			site = null;
		}

		return site;
	},

	removeSub: function(host) {
		if (host.search('.')==-1) return host;

		var testip = host.replace(/\./g,"");
		if (!isNaN(testip)) return host;

		var domain = host.split('.');
		if (domain.length<3) return domain.join('.');

		var ext = domain[domain.length-2];
		if (ext=='co' || ext=='com' || ext=='org') {
			return domain[domain.length-3]+'.'+domain[domain.length-2]+'.'+domain[domain.length-1];
		} else {
			return domain[domain.length-2]+'.'+domain[domain.length-1];
		}
	},

	showData: function() {
		var item = this.getData();
		if (!item) return false;
		var win = this.getMainWin();
		document.getElementById('RemCk').setAttribute('disabled',false);
		document.getElementById('Extend').setAttribute('disabled',false);
		var nme = item[1] + '||' + item[2] + '||' + item[0] + '||' + item[3] + '||' + item[4] + '||' + item[6];

		if (this.testProtect(nme)) {
			document.getElementById('protect').setAttribute('disabled',true);
			document.getElementById('unprotect').setAttribute('disabled',false);
			document.getElementById('RemCk').setAttribute('disabled',true);
		} else if (item[6]==0) {
			document.getElementById('protect').setAttribute('disabled',true);
			document.getElementById('unprotect').setAttribute('disabled',true);
		} else {
			document.getElementById('protect').setAttribute('disabled',false);
			document.getElementById('unprotect').setAttribute('disabled',true);
			document.getElementById('RemCk').setAttribute('disabled',false);
		}

		document.getElementById('csValue').setAttribute('value',item[2]);
		document.getElementById('csPath').setAttribute('value',item[3]);
		document.getElementById('csSecure').setAttribute('value',item[4]);
		document.getElementById('csExpires').setAttribute('value',item[5]);
		return false;
	},

	removeCookie: function() {
		var item = this.getData();
		var ck = this.getCookies();
		ck.remove(item[0],item[1],item[3],false);

		//populate tree based on filter pref
		var tree = document.getElementById('cookiestree');
		var index = tree.currentIndex;
		var list = document.getElementById('csVC-list');
		(list.selectedItem.id=='csVC-item-cur') ? this.filterTree() : this.load();
		if (tree.view.rowCount==index) {
			tree.view.selection.select(index-1);
		} else if (tree.view.rowCount>index) {
			tree.view.selection.select(index);
		}
	},

	removeAll: function() {
		var ck = this.getCookies();
		ck.removeAll();

		//populate tree based on filter pref
		var list = document.getElementById('csVC-list');
		(list.selectedItem.id=='csVC-item-cur') ? this.filterTree() : this.load();
	},

	extendSession: function() {
		var item = this.getData();

		var conf = confirm(this.getSt('viewcookiescs.ExtendExp'));
		if (conf) {
			var exp,i;
			var cookies = "";
			var prefs = this.getPrefs();

			if (item[6]==0) {
				exp = new Date();
				exp = exp.getTime();
			} else {
				exp = (item[6]*1000);
			}

			exp += 31536000000;
			exp = exp/1000;
			exp = parseInt(exp);

			var ck2 = this.getCookies2();
			(item[4]=='true') ? item[4] = true : item[4] = false;
			ck2.add(item[0],item[3],item[1],item[2],item[4],false,exp);

			var win = this.getMainWin();
			var nme = item[1] + '||' + item[2] + '||' + item[0] + '||' + item[3] + '||' + item[4] + '||' + item[6];
			if (this.testProtect(nme)) {
				this.removeProtect(nme);
				win.viewcookiescs.protect.push(item[1] + '||' + item[2] + '||' + item[0] + '||' + item[3] + '||' + item[4] + '||' + exp);
				this.saveProtect();
			}

			//populate tree based on filter pref
			var tree = document.getElementById('cookiestree');
			var index = tree.currentIndex;
			var list = document.getElementById('csVC-list');
			(list.selectedItem.id=='csVC-item-cur') ? this.filterTree() : this.load();
			if (tree.view.rowCount>=index) tree.view.selection.select(index);
		}
	},

	exportToFile: function() {
		var cookie,i;
		var exportlist = "";
		var ck = this.getCookies();
		var list = ck.enumerator;

		while (list.hasMoreElements()) {
			cookie = list.getNext();
			cookie.QueryInterface(Components.interfaces.nsICookie);
			exportlist += cookie.host + '||'
			+ cookie.path + '||'
			+ cookie.name + '||'
			+ cookie.value + '||'
			+ cookie.isSecure + '||'
			+ cookie.expires
			+ "\r\n";
		}

		if (exportlist.substr(-2)=='\r\n') {
			exportlist = exportlist.substr(0,exportlist.length-2);
		}

		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].
        		createInstance(nsIFilePicker);
		fp.init(window, this.getSt('viewcookiescs.SelectLoc'), nsIFilePicker.modeSave);
		fp.appendFilters(nsIFilePicker.filterText);
		fp.defaultExtension = ".txt";
		fp.defaultString = "cookies.txt";
		var res = fp.show();
		if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace) {
  			var thefile = fp.file;
			this.writeFile(thefile,exportlist);
		}
	},

	writeFile: function(sFilePath, sFileContent) {
		var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
			createInstance(Components.interfaces.nsIFileOutputStream);
		strm.QueryInterface(Components.interfaces.nsIOutputStream);
		strm.QueryInterface(Components.interfaces.nsISeekableStream);
		strm.init(sFilePath, 0x04 | 0x08, 420, 0);
		strm.write(sFileContent, sFileContent.length);
		strm.flush();
		strm.close();
	},

	importFromFile: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].
        		createInstance(nsIFilePicker);
		fp.init(window, this.getSt('viewcookiescs.SelectFile'), nsIFilePicker.modeOpen);
		fp.appendFilters(nsIFilePicker.filterText);
		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
  			var thefile = fp.file;
			this.fileReadLine(thefile);
		}

		//populate tree based on filter pref
		var list = document.getElementById('csVC-list');
		(list.selectedItem.id=='csVC-item-cur') ? this.filterTree() : this.load();
	},

	fileReadLine: function(file) {
		var i,temp,ses;
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].
			createInstance(Components.interfaces.nsIFileInputStream);
		istream.init(file, 0x01, 0444, 0);
		istream.QueryInterface(Components.interfaces.nsILineInputStream);

		// read lines into array
		var line = {}, lines = [], hasmore;
		do {
			hasmore = istream.readLine(line);
			lines.push(line.value);
		} while(hasmore);

		istream.close();

		var clear = confirm(this.getSt('viewcookiescs.CkWarning'));
		if (clear) {
			var ck = this.getCookies();
			ck.removeAll();
		}

		// save imported data
		var ck2 = this.getCookies2();

		for (i=0; i<lines.length; ++i) {
			if (!lines[i]) continue;
			temp = lines[i].split('||');
			(temp[4]=='true') ? temp[4] = true : temp[4] = false;
			(temp[5]==0) ? ses = true : ses = false;
			ck2.add(temp[0],temp[1],temp[2],temp[3],temp[4],ses,temp[5]);
		}
	},

	clearColData: function() {
		var tree = document.getElementById('cookiestree');
		tree.view.selection.clearSelection();
		document.getElementById('RemCk').setAttribute('disabled',true);
		document.getElementById('Extend').setAttribute('disabled',true);
		document.getElementById('protect').setAttribute('disabled',true);
		document.getElementById('unprotect').setAttribute('disabled',true);
		document.getElementById('csValue').setAttribute('value','');
		document.getElementById('csPath').setAttribute('value','');
		document.getElementById('csSecure').setAttribute('value','');
		document.getElementById('csExpires').setAttribute('value','');
	},

	clearProtected: function() {
		var prefs = this.getPrefs();
		var yes = confirm(this.getSt('viewcookiescs.ResetProt'));
		if (yes) {
			prefs.setCharPref('protected','');
			var win = this.getMainWin();
			win.viewcookiescs.protect = [];

			//populate tree based on filter pref
			var tree = document.getElementById('cookiestree');
			var index = tree.currentIndex;
			var list = document.getElementById('csVC-list');
			(list.selectedItem.id=='csVC-item-cur') ? this.filterTree() : this.load();
			if (tree.view.rowCount>=index) tree.view.selection.select(index);
		}
	},

	Protect: function() {
		var item = this.getData();
		var win = this.getMainWin();
		var cookie = item[1] + '||' + item[2] + '||' + item[0] + '||' + item[3] + '||' + item[4] + '||' + item[6];
		this.removeProtect(cookie);
		win.viewcookiescs.protect.push(cookie);
		this.saveProtect();

		//populate tree based on filter pref
		var tree = document.getElementById('cookiestree');
		var index = tree.currentIndex;
		var list = document.getElementById('csVC-list');
		(list.selectedItem.id=='csVC-item-cur') ? this.filterTree() : this.load();
		if (tree.view.rowCount>=index) tree.view.selection.select(index);
	},

	Unprotect: function() {
		var item = this.getData();
		var win = this.getMainWin();
		var cookie = item[1] + '||' + item[2] + '||' + item[0] + '||' + item[3] + '||' + item[4] + '||' + item[6];
		this.removeProtect(cookie);
		this.saveProtect();

		//populate tree based on filter pref
		var tree = document.getElementById('cookiestree');
		var index = tree.currentIndex;
		var list = document.getElementById('csVC-list');
		(list.selectedItem.id=='csVC-item-cur') ? this.filterTree() : this.load();
		if (tree.view.rowCount>=index) tree.view.selection.select(index);
	}
};