/***************************************************************************
Name: View Cookies CS
Version: 1.0
Description: Basic cookie manager.
Author: Ron Beckman
Homepage: http://forum.softwareblaze.com
Email: scorpiondb@scorpiondb.com

Copyright (C) 2005  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/



window.addEventListener('load',csLoadCookies,false);

function csLoadCookies() {
	csPageInfo.onDialogLoad();
}

window.addEventListener('unload',csUnloadCookies,false);

function csUnloadCookies() {
	csPageInfo.onDialogClose();
}


var csPageInfo = {

	onDialogLoad: function() {
		var prefs = this.getPrefs();
		var settings = prefs.getCharPref('treeSettings');
		settings = settings.split('::');
		var hide = settings[0].split('||');
		document.getElementById('cookies-site').setAttribute('hidden',hide[0]);
		document.getElementById('cookies-name').setAttribute('hidden',hide[1]);
		document.getElementById('cookies-value').setAttribute('hidden',hide[2]);
		document.getElementById('cookies-path').setAttribute('hidden',hide[3]);
		document.getElementById('cookies-secure').setAttribute('hidden',hide[4]);
		document.getElementById('cookies-expires').setAttribute('hidden',hide[5]);
		document.getElementById('cookies-expires-ms').setAttribute('hidden',hide[6]);
		document.getElementById('cookies-prtct').setAttribute('hidden',hide[7]);

		var list = document.getElementById('csVC-list');
		var all = document.getElementById('csVC-item-all');
		var cur = document.getElementById('csVC-item-cur');
		var filter = prefs.getBoolPref('filterTree');
		(filter) ? list.selectedItem = cur : list.selectedItem = all;
		(filter) ? csViewCookies.filterTree() : csViewCookies.load();
	},

	onDialogClose: function() {
		var hide = [];
		hide.push(document.getElementById('cookies-site').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-name').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-value').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-path').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-secure').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-expires').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-expires-ms').getAttribute('hidden'));
		hide.push(document.getElementById('cookies-prtct').getAttribute('hidden'));
		var prefs = this.getPrefs();
		var size = prefs.getCharPref('treeSettings');
		size = size.split('::');
		var settings = hide.join('||') + '::' + size[1];
		prefs.setCharPref('treeSettings',settings);

		var tf;
		var list = document.getElementById('csVC-list');
		(list.selectedItem.id=='csVC-item-cur') ? tf = true : tf = false;
		prefs.setBoolPref('filterTree',tf);

		var win = this.getMainWin();
		if (win.cookiesafe) {
			win.cookiesafe.resetIcon();
			win.cookiesafe.load();
		}
		window.close();
	},

	getMainWin: function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].
		getService(Components.interfaces.nsIWindowMediator).
		getMostRecentWindow("navigator:browser");
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("viewcookiescs.");
	}
};